#ifndef MODULE_H
#define MODULE_H

#include <QString>

class Message;

class Module
{
private:
    bool enabled;
    QString nick;
    QString chan;

protected:
    QString answer;

    QString pong(QString target);
    QString join(QString theChan);
    QString privateSay(QString str, QString target);
    QString whois(QString nick);
    QString say(QString str);
    QString action(QString str);
    QString quit(QString str);

public:
    Module() : enabled(true) {}

    virtual bool messageHandler(Message msg);
    virtual QString getName();

    QString getAnswer();
    bool isEnabled();
    void setEnabled(bool newStatus);
    QString getNick();
    QString getChan();
    void setNick(QString nick_);
    void setChan(QString chan_);
    // TODO: add serialization methods
};

#endif // MODULE_H
